-- Praktikum digitaler Schaltungsentwurf 1, Aufgabe 2
-- Datei: LFSR.vhdl
--
-- VHDL-Beschreibung eines linear rückgekoppelten
-- SchieberegistersS
--
-- 11.01.2011, G. Kemnitz
------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity LFSR is
 generic (
  RK: std_logic_vector:="0010");
 port (T, I: in std_logic;
  y: out std_logic_vector(RK'length-1 downto 0));
end entity;

architecture a of LFSR is
 signal I_del: std_logic;
 signal z: std_logic_vector(RK'length-1 downto 0);
begin

 -- Abtasten des Initialisierungssignals
 process(T)
 begin
  if rising_edge(T) then 
   I_del <= I;
  end if;
 end process;

 -- Beschreibung des rückgekoppelten Schieberegisters
 process(I_del, T) 
 begin
  if I_del='1' then
   z <= (others=>'1');
  elsif rising_edge(T) then
   if z(z'high)='0' then
    z <= z(z'high-1 downto 0) & z(z'high);
   else 
    z <= (z(z'high-1 downto 0) & z(z'high)) xor RK;
   end if;
  end if;
 end process;
 y <= z;
end architecture;

